// 	$Id: board.cpp,v 1.2 2000/08/13 10:38:41 qoda Exp $	
#include "board.h"
#include <stdio.h>
#include <stdlib.h>

/*
========================================================================
ǽ: 󥹥ȥ饯
: _wx = ܡɤβ
      _wy = ܡɤνĥ
: ʤ
­: 
========================================================================
*/
puzzle_board::puzzle_board(int _wx, int _wy)
{
	wx = _wx;
	wy = _wy;
	board = new int[wx*wy];
	clear_board();
}


/*
========================================================================
ǽ: ǥȥ饯
: 
: 
­: 
========================================================================
*/
puzzle_board::~puzzle_board()
{
	delete board;
}


/*
========================================================================
ǽ: ܡɤ֤ˤ
: ʤ
: ʤ
­: ¤֤˽롣right_pos / wrong_pos
========================================================================
*/
void
puzzle_board::clear_board()
{
	int x, y;

	for (y=0; y<wy; y++) {
		for (x=0; x<wx; x++) {
			board[y*wx + x] = y*wx + x;
		}
	}
	cx = wx - 1;
	cy = wy - 1;
	board[cy*wx + cx] = -1;
	right_pos = wx*wy - 1;
	wrong_pos = 0;
}


/*
========================================================================
ǽ: ܡɤˤФФˤ
: ʤ
: ʤ
­: ֤ˤ𤬰Ĥʤʤޤǰư򷫤֤
========================================================================
*/
void
puzzle_board::init_board()
{
	int last, v, vx, vy;
	
	clear_board();  // ޤϽ
	last = -1;
	while(right_pos!=0) {
		for(;;) {
			v = rand() % 4;
			if (reverse_vect(v)==last) continue;
			vect(v, &vx, &vy);
			if (cx + vx >= wx || cx + vx < 0 || cy + vy >= wy || cy + vy < 0) {
				continue;
			}
			last = v;
			break;
		}
		move_hole(v);
	}
}


/*
========================================================================
ǽ: ˰ư
: v = ٥ȥ륳(vect()ʤɤ򻲾)
: ʤ
­: 
========================================================================
*/
void
puzzle_board::move_hole(int v)
{
	int flag, vx, vy;

	vect(v, &vx, &vy);
	if (cx + vx >= wx || cx + vx < 0 || cy + vy >= wy || cy + vy < 0) {
		// ưޤ
		return;
	}
	if (board[(cy + vy)*wx + (cx + vx)]==(cy + vy)*wx + (cx + vx)) {
		flag = 0;  // ˤ
	} else {
		flag = 1;  // ʰ֤ˤԡư
	}
	board[cy*wx + cx] = board[(cy + vy)*wx + (cx + vx)];
	board[(cy + vy)*wx + (cx + vx)] = -1;
	if (flag==0) {
		right_pos--;
		wrong_pos++;
	} else {
		if (board[cy*wx + cx]==cy*wx + cx) {
			right_pos++;
			wrong_pos--;
		}
	}
	cx += vx;
	cy += vy;
}


/*
========================================================================
ǽ: Υ٥ȥ륳ɤx,yʬʬ򤹤
: v = ٥ȥ륳
      vx = -1, 1, 0Τɤ줫
      vy = -1, 1, 0Τɤ줫
: ʤ
­: ǻѤ٥ȥ륳ѥ桼ƥƥ
========================================================================
*/
void
puzzle_board::vect(int v, int *vx, int *vy)
{
	switch(v) {
	case 0:
		*vx = -1;
		*vy = 0;
		break;
	case 1:
		*vx = 1;
		*vy = 0;
		break;
	case 2:
		*vx = 0;
		*vy = -1;
		break;
	default:
	case 3:
		*vx = 0;
		*vy = 1;
		break;
	}
}


/*
========================================================================
ǽ: Υ٥ȥ륳ɤȿž
: v = ٥ȥ륳
: ȿž٥ȥ륳
­: ե٥ȥ֤
========================================================================
*/
int
puzzle_board::reverse_vect(int v)
{
	switch(v) {
	case 0:
		return 1;
	case 1:
		return 0;
	case 2:
		return 3;
	case 3:
	default:
		return 2;
	}
}


/*
========================================================================
ǽ: x,yʬ٥ȥ륳ɤ
: vx,vy = ٥ȥʬ
: ٥ȥ륳
­: 
========================================================================
*/
int
puzzle_board::get_vect(int vx, int vy)
{
	if (vx==-1 && vy==0) return 0;
	if (vx==1 && vy==0) return 1;
	if (vx==0 && vy==-1) return 2;
	return 3;
}


/*
========================================================================
ǽ: ֤ζ֤ͤ
: x,y = Ĵ٤
: 
­: ͤ0-1Ϸ꤫顼ˤʤ
========================================================================
*/
int
puzzle_board::get_piece(int x, int y)
{
	if (x<0 || x>=wx || y<0 || y>=wy) return -1;  // 
	return board[y*wx + x];
}


/*
========================================================================
ǽ: ΰ֤򥯥åȤΰư¹Ԥ
: x,y = ܡɾΰ
: ư!=0ˤʤ
­: ΰ֤x,yĴ٤ƹԤ꤬Ƥ褦ʤ
      ˸äƤޤȤưư롣
	  ˤäƤϰưǤʤ⤢ΤǷ̤ǧ
========================================================================
*/
int
puzzle_board::push_pos(int x, int y)
{
	int f, tx, t2x, ty, t2y;
	if (x<0 || x>=wx || y<0 || y>=wy) return 0;  // 
	if (board[y*wx + x]==-1) return 0;  // 
	f = 0;
	for (tx=0; tx<wx; tx++) {
		if (board[y*wx + tx]==-1) {
			// X˷꤬
			if (tx < x) {
				// ư
				for(t2x=tx; t2x<x; t2x++) {
					board[y*wx + t2x] = board[y*wx + t2x + 1];
				}
				board[y*wx + x] = -1;
			} else {
				// ư
				for(t2x=tx; t2x>x; t2x--) {
					board[y*wx + t2x] = board[y*wx + t2x - 1];
				}
				board[y*wx + x] = -1;
			}
			f = 1;
			break;
		}
	}
	if (f==0) {
		for (ty=0; ty<wy; ty++) {
			if (board[ty*wx + x]==-1) {
				// Y˷꤬
				if (ty < y) {
					// ư
					for(t2y=ty; t2y<y; t2y++) {
						board[t2y*wx + x] = board[(t2y + 1)*wx + x];
					}
					board[y*wx + x] = -1;
				} else {
					// ư
					for(t2y=ty; t2y>y; t2y--) {
						board[t2y*wx + x] = board[(t2y - 1)*wx + x];
					}
					board[y*wx + x] = -1;
				}
				f = 1;
				break;
			}
		}
	}
	if (f) {
		// ư
		right_pos = wrong_pos = 0;
		for (ty=0; ty<wy; ty++) {
			for (tx=0; tx<wx; tx++) {
				if (board[ty*wx + tx]==-1) {
					continue;
				}
				if (board[ty*wx + tx]==ty*wx + tx) {
					right_pos++;
				} else {
					wrong_pos++;
				}
			}
		}
	}
	return f;
}


